# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class OperationalizationClusterProperties(Model):
    """Properties of an operationalization cluster.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param description: The description of the cluster.
    :type description: str
    :ivar created_on: The date and time when the cluster was created.
    :vartype created_on: str
    :ivar modified_on: The date and time when the cluster was last modified.
    :vartype modified_on: str
    :ivar provisioning_state: The provision state of the cluster. Valid values
     are Unknown, Updating, Provisioning, Succeeded, and Failed. Possible
     values include: 'Unknown', 'Updating', 'Creating', 'Deleting', 'Updated',
     'Accepted', 'Succeeded', 'Failed', 'Canceled'
    :vartype provisioning_state: str or :class:`OperationStatus
     <azure.mgmt.machinelearningcompute.models.OperationStatus>`
    :param cluster_type: The cluster type. Possible values include: 'ACS',
     'Another'
    :type cluster_type: str or :class:`ClusterType
     <azure.mgmt.machinelearningcompute.models.ClusterType>`
    :param storage_account: Storage Account properties.
    :type storage_account: :class:`StorageAccountProperties
     <azure.mgmt.machinelearningcompute.models.StorageAccountProperties>`
    :param container_registry: Container Registry properties.
    :type container_registry: :class:`ContainerRegistryProperties
     <azure.mgmt.machinelearningcompute.models.ContainerRegistryProperties>`
    :param container_service: Parameters for the Azure Container Service
     cluster.
    :type container_service: :class:`AcsClusterProperties
     <azure.mgmt.machinelearningcompute.models.AcsClusterProperties>`
    :param app_insights: AppInsights configuration
    :type app_insights: :class:`AppInsightsCredentials
     <azure.mgmt.machinelearningcompute.models.AppInsightsCredentials>`
    :param global_service_configuration: Contains global configuration for the
     web services in the cluster.
    :type global_service_configuration: :class:`GlobalServiceConfiguration
     <azure.mgmt.machinelearningcompute.models.GlobalServiceConfiguration>`
    """

    _validation = {
        'created_on': {'readonly': True},
        'modified_on': {'readonly': True},
        'provisioning_state': {'readonly': True},
        'cluster_type': {'required': True},
        'container_service': {'required': True},
    }

    _attribute_map = {
        'description': {'key': 'description', 'type': 'str'},
        'created_on': {'key': 'createdOn', 'type': 'str'},
        'modified_on': {'key': 'modifiedOn', 'type': 'str'},
        'provisioning_state': {'key': 'provisioningState', 'type': 'str'},
        'cluster_type': {'key': 'clusterType', 'type': 'str'},
        'storage_account': {'key': 'storageAccount', 'type': 'StorageAccountProperties'},
        'container_registry': {'key': 'containerRegistry', 'type': 'ContainerRegistryProperties'},
        'container_service': {'key': 'containerService', 'type': 'AcsClusterProperties'},
        'app_insights': {'key': 'appInsights', 'type': 'AppInsightsCredentials'},
        'global_service_configuration': {'key': 'globalServiceConfiguration', 'type': 'GlobalServiceConfiguration'},
    }

    def __init__(self, cluster_type, container_service, description=None, storage_account=None, container_registry=None, app_insights=None, global_service_configuration=None):
        self.description = description
        self.created_on = None
        self.modified_on = None
        self.provisioning_state = None
        self.cluster_type = cluster_type
        self.storage_account = storage_account
        self.container_registry = container_registry
        self.container_service = container_service
        self.app_insights = app_insights
        self.global_service_configuration = global_service_configuration
