# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator 1.1.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.service_client import ServiceClient
from msrest import Serializer, Deserializer
from msrestazure import AzureConfiguration
from .version import VERSION
from .operations.mms_ops import ModelManagementAccountsOperations
from . import models


class AzureMachineLearningModelManagementAccountConfiguration(AzureConfiguration):
    """Configuration for AzureMachineLearningModelManagementAccount
    Note that all parameters used to create this instance are saved as instance
    attributes.

    :param credentials: Credentials needed for the client to connect to Azure.
    :type credentials: :mod:`A msrestazure Credentials
     object<msrestazure.azure_active_directory>`
    :param subscription_id: The Azure subscription ID.
    :type subscription_id: str
    :param str base_url: Service URL
    """

    def __init__(
            self, credentials, subscription_id, base_url=None):

        if credentials is None:
            raise ValueError("Parameter 'credentials' must not be None.")
        if subscription_id is None:
            raise ValueError("Parameter 'subscription_id' must not be None.")
        if not isinstance(subscription_id, str):
            raise TypeError("Parameter 'subscription_id' must be str.")
        if not base_url:
            base_url = 'https://management.azure.com'

        super(AzureMachineLearningModelManagementAccountConfiguration, self).__init__(base_url)

        self.add_user_agent('azuremachinelearningmodelmanagementaccount/{}'.format(VERSION))
        self.add_user_agent('Azure-SDK-For-Python')

        self.credentials = credentials
        self.subscription_id = subscription_id


class AzureMachineLearningModelManagementAccount(object):
    """These APIs allow end users to operate on Azure Machine Learning Model Management Account. They support the following operations:&lt;ul&gt;&lt;li&gt;Create or update a Model Management Account&lt;/li&gt;&lt;li&gt;Get a Model Management Account&lt;/li&gt;&lt;li&gt;Patch a Model Management Account&lt;/li&gt;&lt;li&gt;Delete a Model Management Account&lt;/li&gt;&lt;li&gt;Get all Model Management Accounts in a Resource Group &lt;/li&gt;&lt;li&gt;Get all Model Management Account in a Subscription&lt;/li&gt;&lt;/ul&gt;

    :ivar config: Configuration for client.
    :vartype config: AzureMachineLearningModelManagementAccountConfiguration

    :ivar model_management_accounts: ModelManagementAccounts operations
    :vartype model_management_accounts: modelmanagementaccounts.operations.ModelManagementAccountsOperations

    :param credentials: Credentials needed for the client to connect to Azure.
    :type credentials: :mod:`A msrestazure Credentials
     object<msrestazure.azure_active_directory>`
    :param subscription_id: The Azure subscription ID.
    :type subscription_id: str
    :param str base_url: Service URL
    """

    def __init__(
            self, credentials, subscription_id, base_url=None):

        self.config = AzureMachineLearningModelManagementAccountConfiguration(credentials, subscription_id, base_url)
        self._client = ServiceClient(self.config.credentials, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = '2017-09-01-preview'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        self.model_management_accounts = ModelManagementAccountsOperations(
            self._client, self.config, self._serialize, self._deserialize)
